{$O+,Q+,R+,S+}
program pic_slow;
{$APPTYPE CONSOLE}
uses
  SysUtils;
const
     InFile                     = 'pic.inp';
     OutFile                    = 'pic.sol';
     MaxN                       = 151;
     MaxM                       = 1501;
var
   Small                        : array[1..MaxN,1..MaxN] of Byte;
   Big                          : array[1..MaxM,1..MaxM] of Byte;
   Ni, Nj, Mi, Mj, Ans          : Integer;
   Fi, Fo                       : Text;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure InPut;
var
   I, J                         : Integer;
begin
//reading small picture
  for I := 1 to Ni do begin
    for J := 1 to Nj do Read(Fi, Small[I,J]);
    ReadLn(Fi);
  end;

//reading big picture
  for I := 1 to Mi do begin
    for J := 1 to Mj do Read(Fi, Big[I,J]);
    ReadLn(Fi);
  end;
end;


{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
function Match(I, J : Integer) : Boolean;
var
        K, L                    : Integer;
begin
  for K := 1 to Ni do
    for L := 1 to Nj do
      if Small[K,L] <> Big[I+K-1,J+L-1] then
        begin Match := False; Exit; end;
  Match := True;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure Go;
var
        I, J                    : Integer;
begin
  Ans := 0;
  for I := 1 to Mi do
begin if I mod 10 = 0 then WriteLn(I);
    for J := 1 to Mj do
      if Match(I,J) then Inc(Ans);
end;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure Init;
begin
  Assign(Fi, InFile); ReSet(Fi);
  Assign(Fo, OutFile); ReWrite(Fo);

  ReadLn(Fi, Nj, Ni, Mj, Mi);
  repeat
    InPut;

    Go;

    WriteLn(Fo, Ans);

    ReadLn(Fi, Nj, Ni, Mj, Mi);
{}    WriteLn(Nj:5, Ni:5, Mj:5, Mi:5); //ReadLn;
  until Ni = 0;

  Close(Fi); Close(Fo);
end;
{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
begin
  Init;
end.

