{$O+,Q+,R+,S+}
program tests_pic;
{$APPTYPE CONSOLE}
uses SysUtils;
const
     InFile                     = 'pic.inp';
     MaxN                       = 151;
     MaxM                       = 1501;
var
   Small                        : array[1..MaxN,1..MaxN] of Byte;
   Big                          : array[1..MaxM,1..MaxM] of Byte;
   Ni, Nj, Mi, Mj               : Integer;
   Fi                           : Text;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure OutPut;
var
        I, J                    : Integer;
begin
  WriteLn(Fi, Nj, ' ', Ni, ' ', Mj, ' ', Mi);

  for I := 1 to Ni do begin
    Write(Fi, Small[I,1]);
    for J := 2 to Nj do Write(Fi, ' ', Small[I,J]);
    WriteLn(Fi);
  end;

  for I := 1 to Mi do begin
    Write(Fi, Big[I,1]);
    for J := 2 to Mj do Write(Fi, ' ', Big[I,J]);
    WriteLn(Fi);
  end;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure Test01;
begin
  Ni := 1; Nj := 1;
  FillChar(Small, SizeOf(Small), 33);

  Mi := 1; Mj := 1;
  FillChar(Big, SizeOf(Big), 33);

  OutPut;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure Test02;
begin
  WriteLn(Fi, '2 2 3 4');
  WriteLn(Fi, '1 2');
  WriteLn(Fi, '2 1');
  WriteLn(Fi, '1 2 2');
  WriteLn(Fi, '1 2 1');
  WriteLn(Fi, '2 1 2');
  WriteLn(Fi, '1 2 1');
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure Test03;
var
        I, J, K                 : Integer;
begin
  Ni := 3; Nj := 3;
  FillChar(Small, SizeOf(Small), 190); 
  Small[2,2] := 191;


  Mi := 200; Mj := 400;
  FillChar(Big, SizeOf(Big), 190);
  for K := 1 to 2000 do begin
    I := Random(Mi); Inc(I);
    J := Random(Mj); Inc(J);
    Big[I,J] := 191;
  end;

  OutPut;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure Test04;
var
        I, J                    : Integer;
begin
  Ni := 1; Nj := 2;
  for I := 1 to Ni do
    for J := 1 to Nj do
      begin Small[I,J] := Random(100); Inc(Small[I,J],100); end;


  Mi := 500; Mj := 500;
  for I := 1 to Mi do
    for J := 1 to Mj do
      begin Big[I,J] := Random(100); Inc(Big[I,J],100); end;

  OutPut;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure Test05;
var
        I, J                    : Integer;
begin
  Ni := 2; Nj := 2;
  for I := 1 to Ni do
    for J := 1 to Nj do
      begin Small[I,J] := Random(10); Inc(Small[I,J],100); end;


  Mi := 500; Mj := 500;
  for I := 1 to Mi do
    for J := 1 to Mj do
      begin Big[I,J] := Random(10); Inc(Big[I,J],100); end;

  OutPut;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure Test06;
var
        I, J                    : Integer;
begin
  Ni := 100; Nj := 100;
  FillChar(Small, SizeOf(Small), 1);

  Mi := 500; Mj := 500;
  FillChar(Big, SizeOf(Big), 1);
  for I := 1 to 4 do
    for J := 1 to 4 do Big[I*Ni,J*Nj] := 8;

  OutPut;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure Test07;
var
        I, J, K                 : Integer;
begin
  Ni := 150; Nj := 100;
  FillChar(Small, SizeOf(Small), 222);

  Mi := 1000; Mj := 1500;
  FillChar(Big, SizeOf(Big), 222);

  for K := 1 to 700 do begin
    I := Random(Mi); Inc(I);
    J := Random(Mj); Inc(J);
    Big[I,J] := 200;
  end;

  OutPut;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure Test08;
var
        I, J, K                 : Integer;
begin
  Ni := 100; Nj := 150;
  FillChar(Small, SizeOf(Small), 222);

  Mi := 1000; Mj := 1500;
  FillChar(Big, SizeOf(Big), 222);

  for K := 1 to 150 do begin
    I := Random(Mi); Inc(I);
    J := Random(Mj); Inc(J);
    Big[I,J] := 200;
  end;

  OutPut;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure Test09;
var
        I, J, K                 : Integer;
        HelpI, HelpJ            : Integer;
begin
  HelpI := 34;
  HelpJ := 51;

  Ni := 101; Nj := 151;
  for I := 1 to Ni do
  for J := 1 to Nj do
    if (I mod HelpI = 0) and (J mod HelpJ = 0) then begin
      Small[I,J] := Random(2); Inc(Small[I,J]);
    end
    else if (I <= HelpI) and (J <= HelpJ) then begin
      Small[I,J] := Random(255); Inc(Small[I,J]);
    end
    else begin
      Small[I,J] := Small[(I-1) mod HelpI + 1, (J-1) mod HelpJ + 1];
    end;


  Mi := 1019; Mj := 1019;
  for I := 1 to Mi do
  for J := 1 to Mj do
    if (I mod HelpI = 0) and (J mod HelpJ = 0) then begin
      Big[I,J] := Random(2); Inc(Big[I,J]);
    end
    else begin
      Big[I,J] := Small[(I-1) mod HelpI + 1, (J-1) mod HelpJ + 1];
    end;

  OutPut;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure Test10;
begin
  Ni := 150; Nj := 150;
  FillChar(Small, SizeOf(Small), 255);

  Mi := 599; Mj := 599;
  FillChar(Big, SizeOf(Big), 255);

  OutPut;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure Test11;
var
        I, J                    : Integer;
begin
  Ni := 150; Nj := 130;
  FillChar(Small, SizeOf(Small), 1);

  Mi := 1499; Mj := 1299;
  FillChar(Big, SizeOf(Big), 1);
  for I := 1 to 9 do
    for J := 1 to 9 do Big[I*Ni,J*Nj] := 8;

  OutPut;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
begin
//  RandomIze;
  Assign(Fi, InFile); ReWrite(Fi);

  Test01;
  Test02;
  Test03;
  Test04;
  Test05;
  Test06;
  Test07;
  Test08;
  Test09;
  Test10;
  Test11;

  WriteLn(Fi, '0 0 0 0');
  Close(Fi);
end.

